/*M*                     
//                    INTEL CORPORATION PROPRIETARY INFORMATION
//      This software is supplied under the terms of a license agreement or
//      nondisclosure agreement with Intel Corporation and may not be copied
//      or disclosed except in accordance with the terms of that agreement.
//            Copyright (c) 1995 Intel Corporation.  All Rights Reserved.
//
*M*/
/*
 * $Log:   //epg-scc/sst/ProjectDatabases/PI5x/archives/PI 5.0 NetWare/work/SRC/SITKA/IMB_OS.H.v  $
 * 
 *    Rev 1.2   28 Aug 2002 16:39:28   dmondal
 * Modified for IPMI interface detection
 * 
 *    Rev 1.1   May 23 2000 17:23:00   simont
 * 2.3 to 3.0 code merge.
 * 
 *    Rev 1.1   10 Dec 1998 13:41:46   jpaiasno
 * added code to supprt Async DPC events
 * 
 *    Rev 1.0   Sep 20 1998 18:31:28   whcernan
 * Initial revision.
 * 
 *    Rev 1.5   14 Apr 1998 21:41:58   fkhanx
 * Added the Async funcion prototypes
 * 
 *    Rev 1.4   24 Mar 1998 16:00:20   fkhanx
 * Added copyright headers
*/

// This is the Netware version of imb_os.h OS dependent Header file
// This file to be included for the build of netware imbdrv.nlm
#ifndef IMB_OS__

#define IMB_OS__

#include "imb_os2.h"			
#include "imb_log.h"

/*
typedef unsigned char BYTE;
typedef unsigned char UCHAR;
typedef unsigned long IMB_STATUS;
typedef unsigned long DWORD;
typedef void VOID;
typedef unsigned long ImbAsyncOsSem;
typedef unsigned long ImbAsyncOsEvent;
*/




typedef enum {
    False,
    True,
} BOOL;


typedef struct ImbIfStruct DEVICE_EXTENSION;
typedef struct ImbIfStruct * PDEVICE_EXTENSION;

#define FALSE 0
#define TRUE 1

#define NULL 0L

typedef unsigned long NTSTATUS;

#define IMB_SUCCESS 0L
#define STATUS_SUCCESS 0L



void writePortUchar(int x, char y);
void readPortUchar(int x, char *y);


/////////////////////////////////////////////////////////////////////////////////////////////////
// writePortUchar 
/////////////////////////////////////////////////////////////////////////////////////////////////

/*F*
//  Name:       writePortUchar 
//  Purpose:    writes a byte to specified port.
//
//  Context:    used by several functions. 
//
//  Returns:    none
//  Parameters: dx register contains the port address
//              al register contains the byte to be written
//  Notes:      none
*F*/

#pragma aux writePortUchar = \
"pushad",              \
"mov eax,0",            \
"db 0fh",               \
"db 0a2h",               \
"popad",              \
"out DX,AL",           \
"pushad",              \
"mov eax,0"                        \
"db 0fh",               \
"db 0a2h",              \
"popad",              \
parm [EDX] [AL]




/////////////////////////////////////////////////////////////////////////////////////////////////
// readPortUchar 
/////////////////////////////////////////////////////////////////////////////////////////////////

/*F*
//  Name:       readPortUchar 
//  Purpose:    read a byte from a specified port.
//
//  Context:    used by several functions. 
//
//  Returns:    none
//  Parameters: edx  register contains the port address
//              ebx  register contains the buffer address where the
//                   read byte is stored
//  Notes:      none
*F*/

#pragma  aux readPortUchar =  \
"PUSH EAX" ,           \
"pushad",              \
"mov eax,0",               \
"db 0fh",               \
"db 0a2h",               \
"popad",              \
"IN AL,DX",             \
"MOV BYTE PTR [EBX],AL",\
"pushad",               \
"mov eax,0",            \
"db 0fh",               \
"db 0a2h",               \
"popad",              \
"POP EAX",              \
parm [EDX] [EBX]



void TimeOutThread(void *ptr);









int writeMismicCommand( unsigned char command);

int   CheckFunction ();

void  AtOSShutdown();


#define  MISMIC_PROC_CALL_INTERVAL               1000
#define CopyMemory(dst,src,count)	memcpy(dst,src,count)
#define ZeroMemory(dst,count)		memset(dst,0,count)
#define ReadPortUchar(addr,valp) readPortUchar(addr,valp)
#define WritePortUchar(addr,val) writePortUchar(addr,val)
#define MEMORY_MAP_FAILURE        0xC0040013
#define MEMORY_UNMAP_FAILURE      0xC0040014


int MapPhysicalMemory(int startAddress,int addressLength,int *virtualAddress);
int UnmapPhysicalMemory(int virtualAddress);
int CopyPhysicalMemory(BYTE* pSource, BYTE* pDestination, long lNumUnits);



#include "imb_if.h"

#include "imb_asyn.h"




#endif //#ifndef IMB_OS__